Bug 238936 - Cannot compile libjpeg in i386 mode on x86_64 machine
Cannot compile libjpeg in i386 mode on x86_64 machine
Product: Fedora
Classification: Fedora
Component: libjpeg (Show other bugs)
x86_64 Linux
medium Severity low
: ---
: ---
Assigned To: Tom Lane
Depends On:
  Show dependency treegraph
Reported: 2007-05-03 20:14 EDT by Jan Slupski
Modified: 2013-07-02 23:12 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2008-05-06 15:34:25 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
buildlog of libjpeg (58.97 KB, text/plain)
2007-05-03 20:14 EDT, Jan Slupski
no flags Details

  None (edit)
Description Jan Slupski 2007-05-03 20:14:12 EDT
libjpeg build procedure does not pass -m32 (or equivalent) flags to the linker,
so while object files are generated in 32-bit mode, resulting .so file is linked
 in as for x86_64 architecture. Resulting shared library is unusable and build
procedure fails.

This happens when compiling libjpeg-6b-37.src.rpm on x86_64 machine running FC6.

How reproducible:
rpmbuild --rebuild --target=i386 libjpeg-6b-37.src.rpm

Actual results:

/usr/bin/ld: warning: i386 architecture of input file `jcapimin.lo' is
incompatible with i386:x86-64 output
./djpeg -dct int -ppm -outfile testout.ppm  ./testorig.jpg
make: *** [test] Segmentation fault
Comment 1 Jan Slupski 2007-05-03 20:14:12 EDT
Created attachment 154091 [details]
buildlog of libjpeg
Comment 2 Tom Lane 2007-06-25 23:55:11 EDT
Hmm ... in part this is the lack of CFLAGS in the linker calls, which is the same problem complained of in 
bug #244778.  However, after applying their patch and trying to build according to your example, what I 
get is 32-bit libraries installed in /usr/lib64 :-(.  AFAICT this is not the fault of the specfile; %configure is 
generating --libdir=/usr/lib64 so the problem is somewhere in the RPM infrastructure.  I'm not by any 
means an RPM guru; but I wonder whether setting --target is supposed to be enough, or whether you 
must also set --host and/or --build to make this work.

Anyway, please experiment with libjpeg-6b-38, pushed to F7 testing today, since that at least fixes the 
linker-switch problem.
Comment 3 Bug Zapper 2008-04-04 03:11:00 EDT
Fedora apologizes that these issues have not been resolved yet. We're
sorry it's taken so long for your bug to be properly triaged and acted
on. We appreciate the time you took to report this issue and want to
make sure no important bugs slip through the cracks.

If you're currently running a version of Fedora Core between 1 and 6,
please note that Fedora no longer maintains these releases. We strongly
encourage you to upgrade to a current Fedora release. In order to
refocus our efforts as a project we are flagging all of the open bugs
for releases which are no longer maintained and closing them.

If this bug is still open against Fedora Core 1 through 6, thirty days
from now, it will be closed 'WONTFIX'. If you can reporduce this bug in
the latest Fedora version, please change to the respective version. If
you are unable to do this, please add a comment to this bug requesting
the change.

Thanks for your help, and we apologize again that we haven't handled
these issues to this point.

The process we are following is outlined here:

We will be following the process here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping to ensure this
doesn't happen again.

And if you'd like to join the bug triage team to help make things
better, check out http://fedoraproject.org/wiki/BugZappers
Comment 4 Michael Schwendt 2008-04-05 19:40:11 EDT
You also need to remove or adjust  /etc/rpm/platform
Comment 5 Bug Zapper 2008-05-06 15:34:23 EDT
This bug is open for a Fedora version that is no longer maintained and
will not be fixed by Fedora. Therefore we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen thus bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.